﻿function GalaxyHistoryParser() {
}

GalaxyHistoryParser.SPECIAL_CHAR = "#";
GalaxyHistoryParser.PLANET_REF_PREFIX = "PREF";
GalaxyHistoryParser.PLANET_NAME_PREFIX = "PNAME";

GalaxyHistoryParser.SPECIALS_MAX_COUNT = 10;

GalaxyHistoryParser.prototype.parseText = function(text) {
	var result = new Array();

	var i = 0;
	while ((i != -1) && (i < text.length)) {
		var message = new Object();

		var textPartResult = this.parseTextPart(text, i);
		if (!textPartResult) {
			break;
		}
		i = textPartResult.i;
		try {
			message.index = parseInt(textPartResult.textPart);
			if ((message.index === null) || (message.index === undefined) || isNaN(message.index)) {
				break;
			}
		} catch (ex) {
			break;
		}

		textPartResult = this.parseTextPart(text, i);
		if (!textPartResult) {
			break;
		}
		i = textPartResult.i;
		try {
			message.timeMillis = parseInt(textPartResult.textPart);
			if ((message.timeMillis === null) || (message.timeMillis === undefined) || isNaN(message.timeMillis)) {
				break;
			}
		} catch (ex) {
			break;
		}

		textPartResult = this.parseTextPart(text, i);
		if (!textPartResult) {
			break;
		}
		i = textPartResult.i;
		message.userName = textPartResult.textPart;

		textPartResult = this.parseTextPart(text, i);
		if (!textPartResult) {
			break;
		}
		i = textPartResult.i;
		message.text = textPartResult.textPart;
		message.textForList = this.prepareText(message.text, true);
		message.html = this.prepareText(message.text, false);

		result.push(message);
	}

	return result;
};

GalaxyHistoryParser.prototype.parseTextPart = function(text, i) {
	var textPart = "";
	while ((i != -1) && (i < text.length)) {
		var j = text.indexOf(MESSAGE_SEPARATOR, i);
		if (j == -1) {
			break;
		}
		textPart += text.substring(i, j);
		i = j + 1;
		if ((i < text.length) && (text.charAt(i) == MESSAGE_SEPARATOR)) {
			textPart += MESSAGE_SEPARATOR;
			i++;
		} else {
			break;
		}
	}

	if (!textPart) {
		return null;
	}

	var result = new Object();
	result.textPart = textPart;
	result.i = i;
	return result;
};

GalaxyHistoryParser.prototype.prepareText = function(text, forList) {
		var result = text.escapeXML();

		var baseURL = options.getValue(SK_BASE_URL);
		if (!baseURL) {
			baseURL = BASE_URL;
		}

		var i;
		var count = 0;
		while ((result.indexOf(GalaxyHistoryParser.PLANET_REF_PREFIX) != -1)
				&& (count < GalaxyHistoryParser.SPECIALS_MAX_COUNT)) {
			var i = result.indexOf(GalaxyHistoryParser.PLANET_REF_PREFIX);
			var j = result.indexOf(GalaxyHistoryParser.SPECIAL_CHAR, i
					+ GalaxyHistoryParser.PLANET_REF_PREFIX.length);
			var fail = false;
			if (j != -1) {
				var planetIndexStr = result.substring(i + GalaxyHistoryParser
						.PLANET_REF_PREFIX.length, j);
				try {
						var planetName = ("#" + planetIndexStr);
						var k = result.indexOf(GalaxyHistoryParser.PLANET_NAME_PREFIX, j + 1);
						if (k == (j + 1)) {
							var m = result.indexOf(GalaxyHistoryParser.SPECIAL_CHAR,
									k + GalaxyHistoryParser.PLANET_NAME_PREFIX.length);
							if (m != -1) {
								planetName = result.substring(k + GalaxyHistoryParser
										.PLANET_NAME_PREFIX.length, m);
								j = m;
							}
						}
						if (forList) {
							result = (result.substring(0, i) + planetName.escapeXML()
									+ result.substring(j + 1));
						} else {
							result = (result.substring(0, i) + "<a href=\"" + baseURL + "#"
									+ planetIndexStr + "\">" + planetName.escapeXML() + "</a>"
									+ result.substring(j + 1));
						}
				} catch (nothing) {
					fail = true;
				}
			} else {
				fail = true;
			}
			if (fail) {
				result = (result.substring(0, i) + result.substring(i + GalaxyHistoryParser.PLANET_REF_PREFIX.length));
			} else {
				count++;
			}
		}
		return result;
};